'use strict';

var isAnyArray = require('is-any-array');
var arrayMean = require('ml-array-mean');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var arrayMean__default = /*#__PURE__*/_interopDefaultLegacy(arrayMean);

function variance(values, options = {}) {
  if (!isAnyArray.isAnyArray(values)) {
    throw new TypeError('input must be an array');
  }

  const { unbiased = true, mean = arrayMean__default['default'](values) } = options;
  let sqrError = 0;

  for (let i = 0; i < values.length; i++) {
    let x = values[i] - mean;
    sqrError += x * x;
  }

  if (unbiased) {
    return sqrError / (values.length - 1);
  } else {
    return sqrError / values.length;
  }
}

module.exports = variance;
